image:
  name: gitlab-registry.oit.duke.edu/oit-dcc/apptainer-ci/apptainer-ci:latest
  entrypoint: ["/bin/sh", "-c"]
default:
  tags:
    - oit-research
stages:
  - build
  - deploy_latest
  - deploy_tag

build:
  stage: build
  variables:
    SINGULARITYENV_CI_COMMIT_SHORT_SHA: ${CI_COMMIT_SHORT_SHA}
  rules:
    - changes:
      - Singularity.def
  script:
    - apk add curl
    - apptainer build --disable-cache ${CI_PROJECT_NAME}.sif Singularity.def
    - "curl -X POST http://dcc-xfer-01.rc.duke.edu:6000/image \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d '{\"image\": \"'${CI_PROJECT_NAME}'\",\"owner\": \"'${CI_PROJECT_NAMESPACE}'\",\"readme\": \"https://gitlab.oit.duke.edu/'${CI_PROJECT_NAMESPACE}'/'${CI_PROJECT_NAME}'/-/blob/main/README.md\"}'"
  artifacts:
    paths:
      - ${CI_PROJECT_NAME}.sif
    untracked: false
    expire_in: 48 hours

deploy_latest:
  stage: deploy_latest
  rules:
    - if: '$CI_COMMIT_TAG != null'
      when: never
    - changes:
      - Singularity.def
  variables:
    SINGULARITY_DOCKER_USERNAME: ${CI_REGISTRY_USER}
    SINGULARITY_DOCKER_PASSWORD: ${CI_REGISTRY_PASSWORD}
  
  script:
    - singularity push ${CI_PROJECT_NAME}.sif "oras://${CI_REGISTRY_IMAGE}:latest"

deploy_tag:
  stage: deploy_tag
  rules:
    - if: '$CI_COMMIT_TAG != null'
  variables:
    SINGULARITY_DOCKER_USERNAME: ${CI_REGISTRY_USER}
    SINGULARITY_DOCKER_PASSWORD: ${CI_REGISTRY_PASSWORD}
  script:
    - singularity push ${CI_PROJECT_NAME}.sif "oras://${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"
